/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.niederschrift.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractNiederschriftKorrekturSearch {

  @Inject
  protected transient NiederschriftKorrekturExtendedDAO dao;

  public AbstractNiederschriftKorrekturSearch() {
    super();
  }

  public List<NiederschriftKorrektur> getSearchResult(NiederschriftKorrekturSearchParameters searchParameters, EagerLoadingCollector<NiederschriftKorrektur> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<NiederschriftKorrektur> querySearchResult(NiederschriftKorrekturSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
